#!/bin/sh

AUTHENTICATE="0"
DOPSI=0
CHECKXCHECK=`cat /etc/passwd | grep root | cut -d: -f2`
RELOCATE="Refresh: 0;http://"$HTTP_HOST"/hcti_startseite.htm"

#
# Authentication
#

if [ "$REQUEST_METHOD" = "GET" ] ; then

  # Called from Side Menu
  # So "http://" + $HTTP_HOST + "/m_startseite.htm"
  # must be equal to $HTTP_REFERER

  CHECKHOST="http://"$HTTP_HOST"/m_startseite.htm"
  if [ "$CHECKHOST" = "$HTTP_REFERER" ] ; then
    AUTHENTICATE="1"
  fi

else

  #
  # else called from within - do REQUEST INIT and check AUTHENTICATION
  #
  # and check hidden value on variable 'xcheck' written on initialization
  #

  # This is a request, so do PSI updates

  DOPSI=1

#
# Process POST CGI REQUEST and set Variables
#

  QUERY_STRING=`dd count=$CONTENT_LENGTH bs=1 2> /dev/null`"&&"

  # process QUERY_STRING

  while [ "$QUERY_STRING" != "" -a "$QUERY_STRING" != "&" ] ; do

    VARDEF=`/bin/echo $QUERY_STRING | cut -d \& -f 1`
    VAR=`/bin/echo $VARDEF | cut -d = -f 1`
    VAL=`/bin/echo "$VARDEF""=" | cut -d = -f 2`
  
    QUERY_STRING=`/bin/echo $QUERY_STRING | cut -d \& -f 2-`
  
  
    #Set Variables
  
    case $VAR in
  
    tboot)
      settboot=$VAL;;
    sboot)
      setsboot=$VAL;;  
    kboot)
      setkboot=$VAL;;
    takt)
      settakt=$VAL;;
    sakt)
      setsakt=$VAL;;
    xcheck)
      XCHECK=$VAL;;
    *)
      ;;
    esac

  done

  # first do post-authentication

  # Called itself
  # So "http://" + $HTTP_HOST + ":81/index.cgi"
  # must be equal to $HTTP_REFERER

  CHECKHOST="http://"$HTTP_HOST":81/"
  CHECKHOSTZWEI="http://"$HTTP_HOST":81/index.cgi"

  if [ "$CHECKHOST" = "$HTTP_REFERER" ] ; then
  
    #
    # referer is okay, what's with hidden xcheck?
    #
    
    #if [ "$CHECKXCHECK" = "$XCHECK" ] ; then
      AUTHENTICATE="1"
    #fi
  fi
  if [ "$CHECKHOSTZWEI" = "$HTTP_REFERER" ] ; then
  
    #
    # referer is okay, what's with hidden xcheck?
    #
    
    #if [ "$CHECKXCHECK" = "$XCHECK" ] ; then
      AUTHENTICATE="1"
    #fi
  fi
fi


#
# No Authentication?
#

if [ "$AUTHENTICATE" = "0" ] ; then

  echo "$RELOCATE"
  echo ""

else

# Read actual Status

telnetstart=`/sbin/board_control psiinfo | grep bTelnet | sed -e 's/^bTelnet: 0xff/+/'`
sshstart=`/sbin/board_control psiinfo | grep bSSH: | sed -e 's/^bSSH: 0xff/+/'`
sshkeysgen=`/sbin/board_control psiinfo | grep bSSHKeys | sed -e 's/^bSSHKeys: 0xff/+/'`

if [ "$telnetstart" != "+" ] ; then
  telnetstart="-"
fi
if [ "$sshstart" != "+" ] ; then
  sshstart="-"
fi
if [ "$sshkeysgen" != "+" ] ; then
  sshkeysgen="-"
fi
if [ "$settboot" = "Ja" ] ; then
  settboot="+"
else
  settboot="-"
fi
if [ "$setkboot" = "Ja" ] ; then
  setkboot="+"
else
  setkboot="-"
fi
if [ "$setsboot" = "Ja" ] ; then
  setsboot="+"
else
  setsboot="-"
fi

telnetactive=`pidof telnetd`
sshactive=`pidof dropbear`


# If Processed POST Query, then check for differences

if [ $DOPSI -eq 1 ] ; then

  CHANGE_PSI=0
  RESET_PSI=0

  if [ "$setsboot" != "$sshstart" ] ; then
    CHANGE_PSI=1
  fi
  if [ "$settboot" != "$telnetstart" ] ; then
    CHANGE_PSI=1
  fi
  if [ "$setkboot" != "$sshkeysgen" ] ; then
    CHANGE_PSI=1
    RESET_PSI=1
  fi

  if [ $RESET_PSI -eq 1 ] ; then

    `/sbin/board_control rst`
  fi

  if [ $CHANGE_PSI -eq 1 ] ; then
    `/sbin/board_control psiset $settboot $setsboot $setkboot`
  fi


  # And check if anything to start or kill

  if [ "$settakt" = "Ja" -a "$telnetactive" = "" ] ; then
    `/usr/sbin/telnetd telnetd -l /bin/login`
    telnetactive=`pidof telnetd`
  fi
  if [ "$settakt" = "Nein" -a "$telnetactive" != "" ] ; then
    `kill $telnetactive`
    telnetactive=""
  fi
  if [ "$setsakt" = "Ja" -a "$sshactive" = "" ] ; then
    `/bin/dropbear`
    sshactive=`pidof dropbear`
  fi
  if [ "$setsakt" = "Nein" -a "$sshactive" != "" ] ; then
    `kill $sshactive`
    sshactive=""
  fi

  #
  # at last - new location
  # 

  echo "$RELOCATE"
  echo ""

else

#
# Show Page
#
echo 'Content-type: text/html'
echo ''
echo '<HTML><HEAD><TITLE>Additional Features</TITLE>'
echo '<LINK rel="stylesheet" href="http://'"$HTTP_HOST"'/style.css" type="text/css">'
echo '<SCRIPT language="JavaScript" src="http://'"$HTTP_HOST"'/js_fade.txt" type="text/JavaScript"></SCRIPT>'
echo '<SCRIPT language="JavaScript" src="http://'"$HTTP_HOST"'/js_menu.txt" type="text/JavaScript"></SCRIPT>'
echo '<SCRIPT language="JavaScript">'
echo '<!--'
if [ "$telnetstart" = "+" ] ; then
  echo "var tboot = 'Ja';"
else
  echo "var tboot = 'Nein';"
fi

if [ "$sshstart" = "+" ] ; then
  echo "var sboot = 'Ja';"
else
  echo "var sboot = 'Nein';"
fi

if [ "$sshkeysgen" = "+" ] ; then
  echo "var kboot = 'Ja';"
else
  echo "var kboot = 'Nein';"
fi

if [ "$telnetactive" = "" ] ; then
  echo "var takt = 'Nein';"
else
  echo "var takt = 'Ja';"
fi

if [ "$sshactive" = "" ] ; then
  echo "var sakt = 'Nein';"
else
  echo "var sakt = 'Ja';"
fi

echo "function setmenu(){"
echo 'top.frames[1].location.href = "http://'"$HTTP_HOST"'/m_startseite.htm";'
echo '}'

echo "function stZrk(){"
echo 'setmenu();'
echo 'top.frames[2].location.href = "http://'"$HTTP_HOST"'/hcti_startseite.htm";'
echo '}'

cat << EOF

function frmLoad() {
  if (takt=='Ja') {
    document.ADDITIONALFEATURES.takt[1].checked = true;
  } else {
    document.ADDITIONALFEATURES.takt[0].checked = true;
  }
  if (sakt=='Ja') {
    document.ADDITIONALFEATURES.sakt[1].checked = true;
  } else {
    document.ADDITIONALFEATURES.sakt[0].checked = true;
  }
  if (kboot == 'Ja') { document.ADDITIONALFEATURES.kboot.checked = true; }
  if (sboot == 'Ja') {
    document.ADDITIONALFEATURES.sboot[1].checked = true;
    } else {
    document.ADDITIONALFEATURES.sboot[0].checked = true;
    tboot='Ja';
    document.ADDITIONALFEATURES.tboot[0].disabled = 1;
  }
  if (tboot == 'Ja') {
    document.ADDITIONALFEATURES.tboot[1].checked = true;
    } else {
    document.ADDITIONALFEATURES.tboot[0].checked = true;
  }
}
function tbootDisable() {
    document.ADDITIONALFEATURES.tboot[1].checked = false;
    document.ADDITIONALFEATURES.tboot[0].checked = true;
    tboot='Nein';
}
function tbootEnable() {
    document.ADDITIONALFEATURES.tboot[1].checked = true;
    document.ADDITIONALFEATURES.tboot[0].checked = false;
    tboot='Ja';
}
function sbootDisable() {
    tbootEnable();
    document.ADDITIONALFEATURES.tboot[0].disabled = 1;
    document.ADDITIONALFEATURES.sboot[1].checked = false;
    document.ADDITIONALFEATURES.sboot[0].checked = true;
    sboot='Nein';
}
function sbootEnable() {
    document.ADDITIONALFEATURES.sboot[1].checked = true;
    document.ADDITIONALFEATURES.sboot[0].checked = false;
    sboot='Ja';
    document.ADDITIONALFEATURES.tboot[0].disabled = 0;
}
function taktDisable() {
    document.ADDITIONALFEATURES.takt[1].checked = false;
    document.ADDITIONALFEATURES.takt[0].checked = true;
    takt='Nein';
}
function taktEnable() {
    document.ADDITIONALFEATURES.takt[1].checked = true;
    document.ADDITIONALFEATURES.takt[0].checked = false;
    takt='Ja';
}
function saktDisable() {
    document.ADDITIONALFEATURES.sakt[1].checked = false;
    document.ADDITIONALFEATURES.sakt[0].checked = true;
    sakt='Nein';
}
function saktEnable() {
    document.ADDITIONALFEATURES.sakt[1].checked = true;
    document.ADDITIONALFEATURES.sakt[0].checked = false;
    sakt='Ja';
}

function btnApply() {
  if (document.ADDITIONALFEATURES.sakt[0].checked == true) {
    document.ADDITIONALFEATURES.sakt.value='Nein';
    } else {
    document.ADDITIONALFEATURES.sakt.value='Ja';
  }
  if (document.ADDITIONALFEATURES.takt[0].checked == true) {
    document.ADDITIONALFEATURES.takt.value='Nein';
    } else {
    document.ADDITIONALFEATURES.takt.value='Ja';
  }
  if (document.ADDITIONALFEATURES.sboot[0].checked == true) {
    document.ADDITIONALFEATURES.sboot.value='Nein';
    } else {
    document.ADDITIONALFEATURES.sboot.value='Ja';
  }
  if (document.ADDITIONALFEATURES.tboot[0].checked == true) {
    document.ADDITIONALFEATURES.tboot.value='Nein';
    } else {
    document.ADDITIONALFEATURES.tboot.value='Ja';
  }
  if (document.ADDITIONALFEATURES.kboot.checked) {
    document.ADDITIONALFEATURES.kboot.value='Ja';
    } else {
    document.ADDITIONALFEATURES.kboot.value='Nein';
    document.ADDITIONALFEATURES.kboot.checked=true;
  }
        //hidden
        //document.ADDITIONALFEATURES..style.visibility='hidden';
        //document.WIRELESS.wlBasicSpeed.style.visibility='hidden';
        //document.WIRELESS.wlChannel.style.visibility='hidden';
        document.getElementById('c_verzoeg1').style.visibility='visible';
        document.getElementById('c_verzoeg2').style.visibility='visible';
        document.getElementById('t_but3').style.visibility='hidden';
        document.getElementById('t_but4').style.visibility='hidden';
        setmenu();
        document.ADDITIONALFEATURES.submit();
}
//-->
</SCRIPT>
</HEAD>
<BODY onLoad="frmLoad()">
<DIV id=c_Frame>
<DIV id=c_border>
<DIV id=c_pfad>Additional Features</DIV>
<DIV id=c_titel>Aktionen bei Routerneustart</DIV>

<DIV id=c_std>
      <table border="0" cellpadding="0" cellspacing="2">
        <tr onmouseover=i_showElem(1) onmouseout=i_showElem(0)>
          <form name='ADDITIONALFEATURES' action='index.cgi' method='POST'>
            <input type="hidden" name="xcheck" value="">
            <td width="116">Telnet:</td>
            <td width="20"><input type="radio" name="tboot" value="Nein" onclick="tbootDisable()"></td>
            <td width="40">Aus</td>

            <td width="20"><input type="radio" name="tboot" value="Ja" onclick="tbootEnable()"></td>
            <td>Ein</td>
        </tr>
      </table>
</DIV>
<DIV id=c_std>
      <table border="0" cellpadding="0" cellspacing="2">
        <tr onmouseover=i_showElem(2) onmouseout=i_showElem(0)>
            <td width="116">Secure Shell (SSH):</td>

            <td width="20"><input type="radio" name="sboot" value="Nein" onclick="sbootDisable()"></td>
            <td width="40">Aus</td>
            <td width="20"><input type="radio" name="sboot" value="Ja" onclick="sbootEnable()"></td>
            <td>Ein</td>
        </tr>
      </table>
</DIV>
<DIV id=c_std>
      <table border="0" cellpadding="0" cellspacing="2">

        <tr onmouseover=i_showElem(3) onmouseout=i_showElem(0)>
            <td width="116">SSH-Schl&uuml;ssel:</td>
            <td width="20"><input type="checkbox" name="kboot" value="Ja"></td>
            <td width="40"></td>
        </tr>
      </table>
</DIV>
<DIV id=c_titel>Serverprogramme</DIV>

<DIV id=c_std>
      <table border="0" cellpadding="0" cellspacing="2">
        <tr onmouseover=i_showElem(4) onmouseout=i_showElem(0)>
            <td width="116">Telnet:</td>
            <td width="20"><input type="radio" name="takt" value="Nein" onclick="taktDisable()"></td>
            <td width="40">Aus</td>
            <td width="20"><input type="radio" name="takt" value="Ja" onclick="taktEnable()"></td>
            <td>Ein</td>

        </tr>
      </table>
</DIV>
<DIV id=c_last>
      <table border="0" cellpadding="0" cellspacing="2">
        <tr onmouseover=i_showElem(5) onmouseout=i_showElem(0)>
            <td width="116">Secure Shell (SSH):</td>
            <td width="20"><input type="radio" name="sakt" value="Nein" onclick="saktDisable()"></td>
            <td width="40">Aus</td>

            <td width="20"><input type="radio" name="sakt" value="Ja" onclick="saktEnable()"></td>
            <td>Ein</td>
            </form>
        </tr>
      </table>
</DIV>
<DIV id=c_leer></DIV>
<DIV id=c_foot></DIV>
</DIV>
<DIV id=c_verzoeg1></DIV>
<DIV id=c_verzoeg2></DIV>

</DIV>
<DIV id=t_Frame>
<DIV id=t_but3 onclick=stZrk() onmouseover=rahmen(1,3) onmouseout=rahmen(0,3)>Zur&uuml;ck &lt;&lt;</DIV>
<DIV id=t_but4 onclick="btnApply()" onmouseover=rahmen(1,4) onmouseout=rahmen(0,4)>Speichern &lt;&lt;</DIV>
</DIV>
<DIV id=i_Frame>
  <DIV id=i_content>
    <h2>Additional Features</h2>
    <p>Hier k&ouml;nnen Sie die Serverprogramme konfigurieren, die beim Serverstart geladen werden sollen.</p>

    <p>Sollte die Secure Shell deaktiviert sein, wird der Telnet-Server automatisch gestartet,
     um ein versehentliches Aussperren aus dem Router zu verhindern.</p>
    <p>Weitere Informationen erhalten Sie, wenn Sie den Mauszeiger &uuml;ber einen Men&uuml;punkt bewegen.</p>
  </DIV>
  <DIV id=i_content1>
    <h2>Aktionen bei Routerstart</h2>
    <p><b>Telnet</b><br>
     Wenn Sie die Option 'Aus' markieren, wird Telnet beim n&auml;chsten Routerstart nicht mehr gestartet.</p>
    <p>Sollte die Secure Shell deaktiviert sein, ist Telnet automatisch immer aktiv.</p>
  </DIV>
  <DIV id=i_content2>
    <h2>Aktionen bei Routerstart</h2>
    <p><b>Secure Shell (SSH)</b><br>
    Wenn Sie die Option 'Aus' markieren, wird die Secure Shell beim n&auml;chsten Routerstart nicht mehr gestartet.</p>
    <p>Sollte die Secure Shell deaktiviert sein, ist Telnet automatisch immer aktiv.</p>
  </DIV>
  <DIV id=i_content3>
    <h2>Aktionen bei Routerstart</h2>
    <p><b>SSH-Schl&uuml;ssel neu erstellen</b><br>
     Ist das Kontrollk&auml;stchen aktiviert, werden beim n&auml;chsten Routerneustart die DSS- und RSA-Schl&uuml;ssel
     f&uuml;r die Secure Shell neu generiert.</p>
  </DIV>
  <DIV id=i_content4>
    <h2>Serverprogramme</h2>
    <p><b>Telnet</b><br>
     Wenn Sie die Option 'Aus' markieren, wird Telnet beim Speichern sofort deaktiviert.</p>
     <p>Diese Einstellung hat keine Auswirkung auf die Aktionen beim Routerstart.</p>
  </DIV>
  <DIV id=i_content5>
    <h2>Serverprogramme</h2>
    <p><b>Secure Shell (SSH)</b><br>
     Wenn Sie die Option 'Aus' markieren, wird der SSH-Server beim Speichern sofort deaktiviert.</p>
     <p>Diese Einstellung hat keine Auswirkung auf die Aktionen beim Routerstart.</p>
  </DIV>
</DIV></BODY></HTML>

EOF

fi
fi
# if/else from AUTHENTICATION